//+------------------------------------------------------------------+
//|                                                              rsx |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  Orange
#property indicator_color4  Orange
#property indicator_color5  DarkGray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_minimum -50
#property indicator_maximum +50
#property indicator_level1   30
#property indicator_level2  -30
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern int    Length      = 14;
extern int    Price       = PRICE_TYPICAL;
extern double Filter      = 10;
extern double FilterPhase = 0;
extern int    Depth       = 3;
extern double Speed       = 0.25;

//
//
//
//
//

double rsx[];
double rsxHuu[];
double rsxHud[];
double rsxHdd[];
double rsxHdu[];
double slope[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,rsxHuu); SetIndexStyle(0, DRAW_HISTOGRAM);
      SetIndexBuffer(1,rsxHud); SetIndexStyle(1, DRAW_HISTOGRAM);
      SetIndexBuffer(2,rsxHdd); SetIndexStyle(2, DRAW_HISTOGRAM);
      SetIndexBuffer(3,rsxHdu); SetIndexStyle(3, DRAW_HISTOGRAM);
      SetIndexBuffer(4,rsx);
      SetIndexBuffer(5,slope);
         Speed = MathMax(MathMin(1.5,Speed),0.1);
         Depth = MathMax(MathMin(10 ,Depth),1);
         IndicatorShortName("Rsx ("+Length+","+Depth+","+DoubleToStr(Speed,2)+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrkBuffer[][41];

int start()
{
   int i,r,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);

   //
   //
   //
   //
   //
   
   double Kg = (3.0)/(2.0+Length); 
   double Hg = 1.0-Kg;
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      wrkBuffer[r][0] = iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),Filter,FilterPhase,i);

         if (i==(Bars-1)) { for (int c=1; c<13; c++) wrkBuffer[r][c] = 0; continue; }  

      //
      //
      //
      //
      //
      
      double mom = wrkBuffer[r][0]-wrkBuffer[r-1][0];
      double moa = MathAbs(mom);
      for (int k=0; k<Depth; k++)
      {
         int kk = k*4;
            wrkBuffer[r][kk+1] = Kg*mom                + Hg*wrkBuffer[r-1][kk+1];
            wrkBuffer[r][kk+2] = Kg*wrkBuffer[r][kk+1] + Hg*wrkBuffer[r-1][kk+2]; mom =         1.5*wrkBuffer[r][kk+1] - Speed * wrkBuffer[r][kk+2];
            wrkBuffer[r][kk+3] = Kg*moa                + Hg*wrkBuffer[r-1][kk+3];
            wrkBuffer[r][kk+4] = Kg*wrkBuffer[r][kk+3] + Hg*wrkBuffer[r-1][kk+4]; moa = MathAbs(1.5*wrkBuffer[r][kk+3] - Speed * wrkBuffer[r][kk+4]);
      }
      if (moa != 0)
           rsx[i] = MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00)-50.0; 
      else rsx[i] = 0;
      
      //
      //
      //
      //
      //
      
      rsxHuu[i] = EMPTY_VALUE;
      rsxHud[i] = EMPTY_VALUE;
      rsxHdd[i] = EMPTY_VALUE;
      rsxHdu[i] = EMPTY_VALUE;
      slope[i]  = slope[i+1];
         if (rsx[i]>rsx[i+1]) slope[i] =  1;
         if (rsx[i]<rsx[i+1]) slope[i] = -1;
         if (rsx[i]>0)
         if (slope[i]==1)
               rsxHuu[i] = rsx[i];
         else  rsxHud[i] = rsx[i];
         if (rsx[i]<0)
         if (slope[i]==1)
               rsxHdu[i] = rsx[i];
         else  rsxHdd[i] = rsx[i];
   }
   
   //
   //
   //
   //
   //
   
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double wrk[][10];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}